<?php
/**
 * Created by PhpStorm.
 * User: RITG (http://ritg.ru)
 * Date: 23.04.2018
 * Time: 17:48
 */

namespace litebox\kassa\lib\Template;


class GenerateData
{
    /**
     * GenerateData constructor.
     * Заполнение объекта по правилам из массива $this->rules
     * @param $dataItem
     */
    public function __construct($dataItem)
    {
        foreach ($this as $key => &$value) {
            if ($this->rules[$key]) {
                $value = $dataItem[$this->rules[$key]];
            }
        }
        unset($this->rules);
    }
    
    /**
     * Функция генерации артикула/кода (для товаров, торговых предложений, заказов и любых других сущностей)
     * используемые $type:
     *  - P: product (простые товары), формат BP[ID товара]
     *  - O: offer (торговые предложения), формат BO[ID торгового предложения]
     *  - O: order (заказы), формат BO[ID заказа]
     *  - D: delivery (доставка), формат BD[ID доставки]
     * Внимание: в ТУ ограничение на длину поля 10 символов
     */
    public function getBitrixDefaultVendorCode($id, $type){
        return 'B'.$type.''.$id;
    }
}